Class | Erubis::PI::TinyEruby
In: | erubis/tiny.rb
Parent: | Object

### Methods

convert evaluate new result

### Constants

EMBEDDED_PATTERN | = | /(^[ \t]*)?<\?rb(\s.*?)\?>([ \t]*\r?\n)?|@(!+)?\{(.*?)\}@/m

### Attributes

src | [R] |

### Public Class methods

new(input=nil, options={})

[Source]

    # File erubis/tiny.rb, line 81
        def initialize(input=nil, options={})
          @escape  = options[:escape] || 'Erubis::XmlHelper.escape_xml'
          @src = convert(input) if input
        end

### Public Instance methods

convert(input)

[Source]

    # File erubis/tiny.rb, line 90
        def convert(input)
          src = "_buf = '';"           # preamble
          pos = 0
          input.scan(EMBEDDED_PATTERN) do |lspace, stmt, rspace, indicator, expr|
            match = Regexp.last_match
            len   = match.begin(0) - pos
            text  = input[pos, len]
            pos   = match.end(0)
            #src << " _buf << '" << escape_text(text) << "';"
            text.gsub!(/['\\]/, '\\\\\&')
            src << " _buf << '" << text << "';" unless text.empty?
            if stmt                # <?rb ... ?>
              if lspace && rspace
                src << "#{lspace}#{stmt}#{rspace}"
              else
                src << " _buf << '" << lspace << "';" if lspace
                src << stmt << ";"
                src << " _buf << '" << rspace << "';" if rspace
              end
            else                       # ${...}, $!{...}
              if !indicator
                src << " _buf << " << @escape << "(" << expr << ");"
              elsif indicator == '!'
                src << " _buf << (" << expr << ").to_s;"
              end
            end
          end
          #rest = $' || input                        # ruby1.8
          rest = pos == 0 ? input : input[pos..-1]   # ruby1.9
          #src << " _buf << '" << escape_text(rest) << "';"
          rest.gsub!(/['\\]/, '\\\\\&')
          src << " _buf << '" << rest << "';" unless rest.empty?
          src << "\n_buf.to_s\n"       # postamble
          return src
        end

evaluate(_context=Object.new)

[Source]

    # File erubis/tiny.rb, line 134
        def evaluate(_context=Object.new)
          if _context.is_a?(Hash)
            _obj = Object.new
            _context.each do |k, v| _obj.instance_variable_set("@#{k}", v) end
            _context = _obj
          end
          _context.instance_eval @src
        end

result(_binding=TOPLEVEL_BINDING)

def escape_text(text)

      return text.gsub!(/['\\]/, '\\\\\&') || text

end

[Source]

    # File erubis/tiny.rb, line 130
        def result(_binding=TOPLEVEL_BINDING)
          eval @src, _binding
        end

[Validate]